git-submodule.shon commit submodule: stop sanitizing config options (89044ba)
   1#!/bin/sh
   2#
   3# git-submodule.sh: add, init, update or list git submodules
   4#
   5# Copyright (c) 2007 Lars Hjemli
   6
   7dashless=$(basename "$0" | sed -e 's/-/ /')
   8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
   9   or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
  10   or: $dashless [--quiet] init [--] [<path>...]
  11   or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
  12   or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
  13   or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
  14   or: $dashless [--quiet] foreach [--recursive] <command>
  15   or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
  16OPTIONS_SPEC=
  17SUBDIRECTORY_OK=Yes
  18. git-sh-setup
  19. git-sh-i18n
  20. git-parse-remote
  21require_work_tree
  22wt_prefix=$(git rev-parse --show-prefix)
  23cd_to_toplevel
  24
  25# Restrict ourselves to a vanilla subset of protocols; the URLs
  26# we get are under control of a remote repository, and we do not
  27# want them kicking off arbitrary git-remote-* programs.
  28#
  29# If the user has already specified a set of allowed protocols,
  30# we assume they know what they're doing and use that instead.
  31: ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
  32export GIT_ALLOW_PROTOCOL
  33
  34command=
  35branch=
  36force=
  37reference=
  38cached=
  39recursive=
  40init=
  41files=
  42remote=
  43nofetch=
  44update=
  45prefix=
  46custom_name=
  47depth=
  48
  49# The function takes at most 2 arguments. The first argument is the
  50# URL that navigates to the submodule origin repo. When relative, this URL
  51# is relative to the superproject origin URL repo. The second up_path
  52# argument, if specified, is the relative path that navigates
  53# from the submodule working tree to the superproject working tree.
  54#
  55# The output of the function is the origin URL of the submodule.
  56#
  57# The output will either be an absolute URL or filesystem path (if the
  58# superproject origin URL is an absolute URL or filesystem path,
  59# respectively) or a relative file system path (if the superproject
  60# origin URL is a relative file system path).
  61#
  62# When the output is a relative file system path, the path is either
  63# relative to the submodule working tree, if up_path is specified, or to
  64# the superproject working tree otherwise.
  65resolve_relative_url ()
  66{
  67        remote=$(get_default_remote)
  68        remoteurl=$(git config "remote.$remote.url") ||
  69                remoteurl=$(pwd) # the repository is its own authoritative upstream
  70        url="$1"
  71        remoteurl=${remoteurl%/}
  72        sep=/
  73        up_path="$2"
  74
  75        case "$remoteurl" in
  76        *:*|/*)
  77                is_relative=
  78                ;;
  79        ./*|../*)
  80                is_relative=t
  81                ;;
  82        *)
  83                is_relative=t
  84                remoteurl="./$remoteurl"
  85                ;;
  86        esac
  87
  88        while test -n "$url"
  89        do
  90                case "$url" in
  91                ../*)
  92                        url="${url#../}"
  93                        case "$remoteurl" in
  94                        */*)
  95                                remoteurl="${remoteurl%/*}"
  96                                ;;
  97                        *:*)
  98                                remoteurl="${remoteurl%:*}"
  99                                sep=:
 100                                ;;
 101                        *)
 102                                if test -z "$is_relative" || test "." = "$remoteurl"
 103                                then
 104                                        die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
 105                                else
 106                                        remoteurl=.
 107                                fi
 108                                ;;
 109                        esac
 110                        ;;
 111                ./*)
 112                        url="${url#./}"
 113                        ;;
 114                *)
 115                        break;;
 116                esac
 117        done
 118        remoteurl="$remoteurl$sep${url%/}"
 119        echo "${is_relative:+${up_path}}${remoteurl#./}"
 120}
 121
 122# Resolve a path to be relative to another path.  This is intended for
 123# converting submodule paths when git-submodule is run in a subdirectory
 124# and only handles paths where the directory separator is '/'.
 125#
 126# The output is the first argument as a path relative to the second argument,
 127# which defaults to $wt_prefix if it is omitted.
 128relative_path ()
 129{
 130        local target curdir result
 131        target=$1
 132        curdir=${2-$wt_prefix}
 133        curdir=${curdir%/}
 134        result=
 135
 136        while test -n "$curdir"
 137        do
 138                case "$target" in
 139                "$curdir/"*)
 140                        target=${target#"$curdir"/}
 141                        break
 142                        ;;
 143                esac
 144
 145                result="${result}../"
 146                if test "$curdir" = "${curdir%/*}"
 147                then
 148                        curdir=
 149                else
 150                        curdir="${curdir%/*}"
 151                fi
 152        done
 153
 154        echo "$result$target"
 155}
 156
 157die_if_unmatched ()
 158{
 159        if test "$1" = "#unmatched"
 160        then
 161                exit 1
 162        fi
 163}
 164
 165#
 166# Print a submodule configuration setting
 167#
 168# $1 = submodule name
 169# $2 = option name
 170# $3 = default value
 171#
 172# Checks in the usual git-config places first (for overrides),
 173# otherwise it falls back on .gitmodules.  This allows you to
 174# distribute project-wide defaults in .gitmodules, while still
 175# customizing individual repositories if necessary.  If the option is
 176# not in .gitmodules either, print a default value.
 177#
 178get_submodule_config () {
 179        name="$1"
 180        option="$2"
 181        default="$3"
 182        value=$(git config submodule."$name"."$option")
 183        if test -z "$value"
 184        then
 185                value=$(git config -f .gitmodules submodule."$name"."$option")
 186        fi
 187        printf '%s' "${value:-$default}"
 188}
 189
 190isnumber()
 191{
 192        n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
 193}
 194
 195# Sanitize the local git environment for use within a submodule. We
 196# can't simply use clear_local_git_env since we want to preserve some
 197# of the settings from GIT_CONFIG_PARAMETERS.
 198sanitize_submodule_env()
 199{
 200        save_config=$GIT_CONFIG_PARAMETERS
 201        clear_local_git_env
 202        GIT_CONFIG_PARAMETERS=$save_config
 203        export GIT_CONFIG_PARAMETERS
 204}
 205
 206#
 207# Add a new submodule to the working tree, .gitmodules and the index
 208#
 209# $@ = repo path
 210#
 211# optional branch is stored in global branch variable
 212#
 213cmd_add()
 214{
 215        # parse $args after "submodule ... add".
 216        reference_path=
 217        while test $# -ne 0
 218        do
 219                case "$1" in
 220                -b | --branch)
 221                        case "$2" in '') usage ;; esac
 222                        branch=$2
 223                        shift
 224                        ;;
 225                -f | --force)
 226                        force=$1
 227                        ;;
 228                -q|--quiet)
 229                        GIT_QUIET=1
 230                        ;;
 231                --reference)
 232                        case "$2" in '') usage ;; esac
 233                        reference_path=$2
 234                        shift
 235                        ;;
 236                --reference=*)
 237                        reference_path="${1#--reference=}"
 238                        ;;
 239                --name)
 240                        case "$2" in '') usage ;; esac
 241                        custom_name=$2
 242                        shift
 243                        ;;
 244                --depth)
 245                        case "$2" in '') usage ;; esac
 246                        depth="--depth=$2"
 247                        shift
 248                        ;;
 249                --depth=*)
 250                        depth=$1
 251                        ;;
 252                --)
 253                        shift
 254                        break
 255                        ;;
 256                -*)
 257                        usage
 258                        ;;
 259                *)
 260                        break
 261                        ;;
 262                esac
 263                shift
 264        done
 265
 266        if test -n "$reference_path"
 267        then
 268                is_absolute_path "$reference_path" ||
 269                reference_path="$wt_prefix$reference_path"
 270
 271                reference="--reference=$reference_path"
 272        fi
 273
 274        repo=$1
 275        sm_path=$2
 276
 277        if test -z "$sm_path"; then
 278                sm_path=$(printf '%s\n' "$repo" |
 279                        sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
 280        fi
 281
 282        if test -z "$repo" || test -z "$sm_path"; then
 283                usage
 284        fi
 285
 286        is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
 287
 288        # assure repo is absolute or relative to parent
 289        case "$repo" in
 290        ./*|../*)
 291                test -z "$wt_prefix" ||
 292                die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
 293
 294                # dereference source url relative to parent's url
 295                realrepo=$(resolve_relative_url "$repo") || exit
 296                ;;
 297        *:*|/*)
 298                # absolute url
 299                realrepo=$repo
 300                ;;
 301        *)
 302                die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
 303        ;;
 304        esac
 305
 306        # normalize path:
 307        # multiple //; leading ./; /./; /../; trailing /
 308        sm_path=$(printf '%s/\n' "$sm_path" |
 309                sed -e '
 310                        s|//*|/|g
 311                        s|^\(\./\)*||
 312                        s|/\(\./\)*|/|g
 313                        :start
 314                        s|\([^/]*\)/\.\./||
 315                        tstart
 316                        s|/*$||
 317                ')
 318        git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
 319        die "$(eval_gettext "'\$sm_path' already exists in the index")"
 320
 321        if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
 322        then
 323                eval_gettextln "The following path is ignored by one of your .gitignore files:
 324\$sm_path
 325Use -f if you really want to add it." >&2
 326                exit 1
 327        fi
 328
 329        if test -n "$custom_name"
 330        then
 331                sm_name="$custom_name"
 332        else
 333                sm_name="$sm_path"
 334        fi
 335
 336        # perhaps the path exists and is already a git repo, else clone it
 337        if test -e "$sm_path"
 338        then
 339                if test -d "$sm_path"/.git || test -f "$sm_path"/.git
 340                then
 341                        eval_gettextln "Adding existing repo at '\$sm_path' to the index"
 342                else
 343                        die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
 344                fi
 345
 346        else
 347                if test -d ".git/modules/$sm_name"
 348                then
 349                        if test -z "$force"
 350                        then
 351                                echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
 352                                GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^,"  ", -e s,' (fetch)',, >&2
 353                                echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
 354                                echo >&2 "  $realrepo"
 355                                echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
 356                                die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
 357                        else
 358                                echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
 359                        fi
 360                fi
 361                git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
 362                (
 363                        sanitize_submodule_env
 364                        cd "$sm_path" &&
 365                        # ash fails to wordsplit ${branch:+-b "$branch"...}
 366                        case "$branch" in
 367                        '') git checkout -f -q ;;
 368                        ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
 369                        esac
 370                ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
 371        fi
 372        git config submodule."$sm_name".url "$realrepo"
 373
 374        git add $force "$sm_path" ||
 375        die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
 376
 377        git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
 378        git config -f .gitmodules submodule."$sm_name".url "$repo" &&
 379        if test -n "$branch"
 380        then
 381                git config -f .gitmodules submodule."$sm_name".branch "$branch"
 382        fi &&
 383        git add --force .gitmodules ||
 384        die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
 385}
 386
 387#
 388# Execute an arbitrary command sequence in each checked out
 389# submodule
 390#
 391# $@ = command to execute
 392#
 393cmd_foreach()
 394{
 395        # parse $args after "submodule ... foreach".
 396        while test $# -ne 0
 397        do
 398                case "$1" in
 399                -q|--quiet)
 400                        GIT_QUIET=1
 401                        ;;
 402                --recursive)
 403                        recursive=1
 404                        ;;
 405                -*)
 406                        usage
 407                        ;;
 408                *)
 409                        break
 410                        ;;
 411                esac
 412                shift
 413        done
 414
 415        toplevel=$(pwd)
 416
 417        # dup stdin so that it can be restored when running the external
 418        # command in the subshell (and a recursive call to this function)
 419        exec 3<&0
 420
 421        git submodule--helper list --prefix "$wt_prefix"|
 422        while read mode sha1 stage sm_path
 423        do
 424                die_if_unmatched "$mode"
 425                if test -e "$sm_path"/.git
 426                then
 427                        displaypath=$(relative_path "$sm_path")
 428                        say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
 429                        name=$(git submodule--helper name "$sm_path")
 430                        (
 431                                prefix="$prefix$sm_path/"
 432                                sanitize_submodule_env
 433                                cd "$sm_path" &&
 434                                sm_path=$(relative_path "$sm_path") &&
 435                                # we make $path available to scripts ...
 436                                path=$sm_path &&
 437                                if test $# -eq 1
 438                                then
 439                                        eval "$1"
 440                                else
 441                                        "$@"
 442                                fi &&
 443                                if test -n "$recursive"
 444                                then
 445                                        cmd_foreach "--recursive" "$@"
 446                                fi
 447                        ) <&3 3<&- ||
 448                        die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
 449                fi
 450        done
 451}
 452
 453#
 454# Register submodules in .git/config
 455#
 456# $@ = requested paths (default to all)
 457#
 458cmd_init()
 459{
 460        # parse $args after "submodule ... init".
 461        while test $# -ne 0
 462        do
 463                case "$1" in
 464                -q|--quiet)
 465                        GIT_QUIET=1
 466                        ;;
 467                --)
 468                        shift
 469                        break
 470                        ;;
 471                -*)
 472                        usage
 473                        ;;
 474                *)
 475                        break
 476                        ;;
 477                esac
 478                shift
 479        done
 480
 481        git submodule--helper list --prefix "$wt_prefix" "$@" |
 482        while read mode sha1 stage sm_path
 483        do
 484                die_if_unmatched "$mode"
 485                name=$(git submodule--helper name "$sm_path") || exit
 486
 487                displaypath=$(relative_path "$sm_path")
 488
 489                # Copy url setting when it is not set yet
 490                if test -z "$(git config "submodule.$name.url")"
 491                then
 492                        url=$(git config -f .gitmodules submodule."$name".url)
 493                        test -z "$url" &&
 494                        die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
 495
 496                        # Possibly a url relative to parent
 497                        case "$url" in
 498                        ./*|../*)
 499                                url=$(resolve_relative_url "$url") || exit
 500                                ;;
 501                        esac
 502                        git config submodule."$name".url "$url" ||
 503                        die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
 504
 505                        say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
 506                fi
 507
 508                # Copy "update" setting when it is not set yet
 509                if upd="$(git config -f .gitmodules submodule."$name".update)" &&
 510                   test -n "$upd" &&
 511                   test -z "$(git config submodule."$name".update)"
 512                then
 513                        case "$upd" in
 514                        checkout | rebase | merge | none)
 515                                ;; # known modes of updating
 516                        *)
 517                                echo >&2 "warning: unknown update mode '$upd' suggested for submodule '$name'"
 518                                upd=none
 519                                ;;
 520                        esac
 521                        git config submodule."$name".update "$upd" ||
 522                        die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
 523                fi
 524        done
 525}
 526
 527#
 528# Unregister submodules from .git/config and remove their work tree
 529#
 530# $@ = requested paths (use '.' to deinit all submodules)
 531#
 532cmd_deinit()
 533{
 534        # parse $args after "submodule ... deinit".
 535        while test $# -ne 0
 536        do
 537                case "$1" in
 538                -f|--force)
 539                        force=$1
 540                        ;;
 541                -q|--quiet)
 542                        GIT_QUIET=1
 543                        ;;
 544                --)
 545                        shift
 546                        break
 547                        ;;
 548                -*)
 549                        usage
 550                        ;;
 551                *)
 552                        break
 553                        ;;
 554                esac
 555                shift
 556        done
 557
 558        if test $# = 0
 559        then
 560                die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
 561        fi
 562
 563        git submodule--helper list --prefix "$wt_prefix" "$@" |
 564        while read mode sha1 stage sm_path
 565        do
 566                die_if_unmatched "$mode"
 567                name=$(git submodule--helper name "$sm_path") || exit
 568
 569                displaypath=$(relative_path "$sm_path")
 570
 571                # Remove the submodule work tree (unless the user already did it)
 572                if test -d "$sm_path"
 573                then
 574                        # Protect submodules containing a .git directory
 575                        if test -d "$sm_path/.git"
 576                        then
 577                                echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
 578                                die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
 579                        fi
 580
 581                        if test -z "$force"
 582                        then
 583                                git rm -qn "$sm_path" ||
 584                                die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
 585                        fi
 586                        rm -rf "$sm_path" &&
 587                        say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
 588                        say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
 589                fi
 590
 591                mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
 592
 593                # Remove the .git/config entries (unless the user already did it)
 594                if test -n "$(git config --get-regexp submodule."$name\.")"
 595                then
 596                        # Remove the whole section so we have a clean state when
 597                        # the user later decides to init this submodule again
 598                        url=$(git config submodule."$name".url)
 599                        git config --remove-section submodule."$name" 2>/dev/null &&
 600                        say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
 601                fi
 602        done
 603}
 604
 605#
 606# Update each submodule path to correct revision, using clone and checkout as needed
 607#
 608# $@ = requested paths (default to all)
 609#
 610cmd_update()
 611{
 612        # parse $args after "submodule ... update".
 613        while test $# -ne 0
 614        do
 615                case "$1" in
 616                -q|--quiet)
 617                        GIT_QUIET=1
 618                        ;;
 619                -i|--init)
 620                        init=1
 621                        ;;
 622                --remote)
 623                        remote=1
 624                        ;;
 625                -N|--no-fetch)
 626                        nofetch=1
 627                        ;;
 628                -f|--force)
 629                        force=$1
 630                        ;;
 631                -r|--rebase)
 632                        update="rebase"
 633                        ;;
 634                --reference)
 635                        case "$2" in '') usage ;; esac
 636                        reference="--reference=$2"
 637                        shift
 638                        ;;
 639                --reference=*)
 640                        reference="$1"
 641                        ;;
 642                -m|--merge)
 643                        update="merge"
 644                        ;;
 645                --recursive)
 646                        recursive=1
 647                        ;;
 648                --checkout)
 649                        update="checkout"
 650                        ;;
 651                --depth)
 652                        case "$2" in '') usage ;; esac
 653                        depth="--depth=$2"
 654                        shift
 655                        ;;
 656                --depth=*)
 657                        depth=$1
 658                        ;;
 659                --)
 660                        shift
 661                        break
 662                        ;;
 663                -*)
 664                        usage
 665                        ;;
 666                *)
 667                        break
 668                        ;;
 669                esac
 670                shift
 671        done
 672
 673        if test -n "$init"
 674        then
 675                cmd_init "--" "$@" || return
 676        fi
 677
 678        cloned_modules=
 679        git submodule--helper list --prefix "$wt_prefix" "$@" | {
 680        err=
 681        while read mode sha1 stage sm_path
 682        do
 683                die_if_unmatched "$mode"
 684                if test "$stage" = U
 685                then
 686                        echo >&2 "Skipping unmerged submodule $prefix$sm_path"
 687                        continue
 688                fi
 689                name=$(git submodule--helper name "$sm_path") || exit
 690                url=$(git config submodule."$name".url)
 691                branch=$(get_submodule_config "$name" branch master)
 692                if ! test -z "$update"
 693                then
 694                        update_module=$update
 695                else
 696                        update_module=$(git config submodule."$name".update)
 697                        if test -z "$update_module"
 698                        then
 699                                update_module="checkout"
 700                        fi
 701                fi
 702
 703                displaypath=$(relative_path "$prefix$sm_path")
 704
 705                if test "$update_module" = "none"
 706                then
 707                        echo "Skipping submodule '$displaypath'"
 708                        continue
 709                fi
 710
 711                if test -z "$url"
 712                then
 713                        # Only mention uninitialized submodules when its
 714                        # path have been specified
 715                        test "$#" != "0" &&
 716                        say "$(eval_gettext "Submodule path '\$displaypath' not initialized
 717Maybe you want to use 'update --init'?")"
 718                        continue
 719                fi
 720
 721                if ! test -d "$sm_path"/.git && ! test -f "$sm_path"/.git
 722                then
 723                        git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$prefix" --path "$sm_path" --name "$name" --url "$url" ${reference:+"$reference"} ${depth:+"$depth"} || exit
 724                        cloned_modules="$cloned_modules;$name"
 725                        subsha1=
 726                else
 727                        subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
 728                                git rev-parse --verify HEAD) ||
 729                        die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
 730                fi
 731
 732                if test -n "$remote"
 733                then
 734                        if test -z "$nofetch"
 735                        then
 736                                # Fetch remote before determining tracking $sha1
 737                                (sanitize_submodule_env; cd "$sm_path" && git-fetch) ||
 738                                die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
 739                        fi
 740                        remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
 741                        sha1=$(sanitize_submodule_env; cd "$sm_path" &&
 742                                git rev-parse --verify "${remote_name}/${branch}") ||
 743                        die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
 744                fi
 745
 746                if test "$subsha1" != "$sha1" || test -n "$force"
 747                then
 748                        subforce=$force
 749                        # If we don't already have a -f flag and the submodule has never been checked out
 750                        if test -z "$subsha1" && test -z "$force"
 751                        then
 752                                subforce="-f"
 753                        fi
 754
 755                        if test -z "$nofetch"
 756                        then
 757                                # Run fetch only if $sha1 isn't present or it
 758                                # is not reachable from a ref.
 759                                (sanitize_submodule_env; cd "$sm_path" &&
 760                                        ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
 761                                         test -z "$rev") || git-fetch)) ||
 762                                die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
 763                        fi
 764
 765                        # Is this something we just cloned?
 766                        case ";$cloned_modules;" in
 767                        *";$name;"*)
 768                                # then there is no local change to integrate
 769                                update_module=checkout ;;
 770                        esac
 771
 772                        must_die_on_failure=
 773                        case "$update_module" in
 774                        checkout)
 775                                command="git checkout $subforce -q"
 776                                die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
 777                                say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
 778                                ;;
 779                        rebase)
 780                                command="git rebase"
 781                                die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
 782                                say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
 783                                must_die_on_failure=yes
 784                                ;;
 785                        merge)
 786                                command="git merge"
 787                                die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
 788                                say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
 789                                must_die_on_failure=yes
 790                                ;;
 791                        !*)
 792                                command="${update_module#!}"
 793                                die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$prefix\$sm_path'")"
 794                                say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
 795                                must_die_on_failure=yes
 796                                ;;
 797                        *)
 798                                die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
 799                        esac
 800
 801                        if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
 802                        then
 803                                say "$say_msg"
 804                        elif test -n "$must_die_on_failure"
 805                        then
 806                                die_with_status 2 "$die_msg"
 807                        else
 808                                err="${err};$die_msg"
 809                                continue
 810                        fi
 811                fi
 812
 813                if test -n "$recursive"
 814                then
 815                        (
 816                                prefix="$prefix$sm_path/"
 817                                sanitize_submodule_env
 818                                cd "$sm_path" &&
 819                                eval cmd_update
 820                        )
 821                        res=$?
 822                        if test $res -gt 0
 823                        then
 824                                die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
 825                                if test $res -eq 1
 826                                then
 827                                        err="${err};$die_msg"
 828                                        continue
 829                                else
 830                                        die_with_status $res "$die_msg"
 831                                fi
 832                        fi
 833                fi
 834        done
 835
 836        if test -n "$err"
 837        then
 838                OIFS=$IFS
 839                IFS=';'
 840                for e in $err
 841                do
 842                        if test -n "$e"
 843                        then
 844                                echo >&2 "$e"
 845                        fi
 846                done
 847                IFS=$OIFS
 848                exit 1
 849        fi
 850        }
 851}
 852
 853set_name_rev () {
 854        revname=$( (
 855                sanitize_submodule_env
 856                cd "$1" && {
 857                        git describe "$2" 2>/dev/null ||
 858                        git describe --tags "$2" 2>/dev/null ||
 859                        git describe --contains "$2" 2>/dev/null ||
 860                        git describe --all --always "$2"
 861                }
 862        ) )
 863        test -z "$revname" || revname=" ($revname)"
 864}
 865#
 866# Show commit summary for submodules in index or working tree
 867#
 868# If '--cached' is given, show summary between index and given commit,
 869# or between working tree and given commit
 870#
 871# $@ = [commit (default 'HEAD'),] requested paths (default all)
 872#
 873cmd_summary() {
 874        summary_limit=-1
 875        for_status=
 876        diff_cmd=diff-index
 877
 878        # parse $args after "submodule ... summary".
 879        while test $# -ne 0
 880        do
 881                case "$1" in
 882                --cached)
 883                        cached="$1"
 884                        ;;
 885                --files)
 886                        files="$1"
 887                        ;;
 888                --for-status)
 889                        for_status="$1"
 890                        ;;
 891                -n|--summary-limit)
 892                        summary_limit="$2"
 893                        isnumber "$summary_limit" || usage
 894                        shift
 895                        ;;
 896                --summary-limit=*)
 897                        summary_limit="${1#--summary-limit=}"
 898                        isnumber "$summary_limit" || usage
 899                        ;;
 900                --)
 901                        shift
 902                        break
 903                        ;;
 904                -*)
 905                        usage
 906                        ;;
 907                *)
 908                        break
 909                        ;;
 910                esac
 911                shift
 912        done
 913
 914        test $summary_limit = 0 && return
 915
 916        if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
 917        then
 918                head=$rev
 919                test $# = 0 || shift
 920        elif test -z "$1" || test "$1" = "HEAD"
 921        then
 922                # before the first commit: compare with an empty tree
 923                head=$(git hash-object -w -t tree --stdin </dev/null)
 924                test -z "$1" || shift
 925        else
 926                head="HEAD"
 927        fi
 928
 929        if [ -n "$files" ]
 930        then
 931                test -n "$cached" &&
 932                die "$(gettext "The --cached option cannot be used with the --files option")"
 933                diff_cmd=diff-files
 934                head=
 935        fi
 936
 937        cd_to_toplevel
 938        eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
 939        # Get modified modules cared by user
 940        modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
 941                sane_egrep '^:([0-7]* )?160000' |
 942                while read mod_src mod_dst sha1_src sha1_dst status sm_path
 943                do
 944                        # Always show modules deleted or type-changed (blob<->module)
 945                        if test "$status" = D || test "$status" = T
 946                        then
 947                                printf '%s\n' "$sm_path"
 948                                continue
 949                        fi
 950                        # Respect the ignore setting for --for-status.
 951                        if test -n "$for_status"
 952                        then
 953                                name=$(git submodule--helper name "$sm_path")
 954                                ignore_config=$(get_submodule_config "$name" ignore none)
 955                                test $status != A && test $ignore_config = all && continue
 956                        fi
 957                        # Also show added or modified modules which are checked out
 958                        GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
 959                        printf '%s\n' "$sm_path"
 960                done
 961        )
 962
 963        test -z "$modules" && return
 964
 965        git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
 966        sane_egrep '^:([0-7]* )?160000' |
 967        cut -c2- |
 968        while read mod_src mod_dst sha1_src sha1_dst status name
 969        do
 970                if test -z "$cached" &&
 971                        test $sha1_dst = 0000000000000000000000000000000000000000
 972                then
 973                        case "$mod_dst" in
 974                        160000)
 975                                sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
 976                                ;;
 977                        100644 | 100755 | 120000)
 978                                sha1_dst=$(git hash-object $name)
 979                                ;;
 980                        000000)
 981                                ;; # removed
 982                        *)
 983                                # unexpected type
 984                                eval_gettextln "unexpected mode \$mod_dst" >&2
 985                                continue ;;
 986                        esac
 987                fi
 988                missing_src=
 989                missing_dst=
 990
 991                test $mod_src = 160000 &&
 992                ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
 993                missing_src=t
 994
 995                test $mod_dst = 160000 &&
 996                ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
 997                missing_dst=t
 998
 999                display_name=$(relative_path "$name")
1000
1001                total_commits=
1002                case "$missing_src,$missing_dst" in
1003                t,)
1004                        errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_src")"
1005                        ;;
1006                ,t)
1007                        errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_dst")"
1008                        ;;
1009                t,t)
1010                        errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1011                        ;;
1012                *)
1013                        errmsg=
1014                        total_commits=$(
1015                        if test $mod_src = 160000 && test $mod_dst = 160000
1016                        then
1017                                range="$sha1_src...$sha1_dst"
1018                        elif test $mod_src = 160000
1019                        then
1020                                range=$sha1_src
1021                        else
1022                                range=$sha1_dst
1023                        fi
1024                        GIT_DIR="$name/.git" \
1025                        git rev-list --first-parent $range -- | wc -l
1026                        )
1027                        total_commits=" ($(($total_commits + 0)))"
1028                        ;;
1029                esac
1030
1031                sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1032                sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1033                if test $status = T
1034                then
1035                        blob="$(gettext "blob")"
1036                        submodule="$(gettext "submodule")"
1037                        if test $mod_dst = 160000
1038                        then
1039                                echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1040                        else
1041                                echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1042                        fi
1043                else
1044                        echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1045                fi
1046                if test -n "$errmsg"
1047                then
1048                        # Don't give error msg for modification whose dst is not submodule
1049                        # i.e. deleted or changed to blob
1050                        test $mod_dst = 160000 && echo "$errmsg"
1051                else
1052                        if test $mod_src = 160000 && test $mod_dst = 160000
1053                        then
1054                                limit=
1055                                test $summary_limit -gt 0 && limit="-$summary_limit"
1056                                GIT_DIR="$name/.git" \
1057                                git log $limit --pretty='format:  %m %s' \
1058                                --first-parent $sha1_src...$sha1_dst
1059                        elif test $mod_dst = 160000
1060                        then
1061                                GIT_DIR="$name/.git" \
1062                                git log --pretty='format:  > %s' -1 $sha1_dst
1063                        else
1064                                GIT_DIR="$name/.git" \
1065                                git log --pretty='format:  < %s' -1 $sha1_src
1066                        fi
1067                        echo
1068                fi
1069                echo
1070        done
1071}
1072#
1073# List all submodules, prefixed with:
1074#  - submodule not initialized
1075#  + different revision checked out
1076#
1077# If --cached was specified the revision in the index will be printed
1078# instead of the currently checked out revision.
1079#
1080# $@ = requested paths (default to all)
1081#
1082cmd_status()
1083{
1084        # parse $args after "submodule ... status".
1085        while test $# -ne 0
1086        do
1087                case "$1" in
1088                -q|--quiet)
1089                        GIT_QUIET=1
1090                        ;;
1091                --cached)
1092                        cached=1
1093                        ;;
1094                --recursive)
1095                        recursive=1
1096                        ;;
1097                --)
1098                        shift
1099                        break
1100                        ;;
1101                -*)
1102                        usage
1103                        ;;
1104                *)
1105                        break
1106                        ;;
1107                esac
1108                shift
1109        done
1110
1111        git submodule--helper list --prefix "$wt_prefix" "$@" |
1112        while read mode sha1 stage sm_path
1113        do
1114                die_if_unmatched "$mode"
1115                name=$(git submodule--helper name "$sm_path") || exit
1116                url=$(git config submodule."$name".url)
1117                displaypath=$(relative_path "$prefix$sm_path")
1118                if test "$stage" = U
1119                then
1120                        say "U$sha1 $displaypath"
1121                        continue
1122                fi
1123                if test -z "$url" ||
1124                {
1125                        ! test -d "$sm_path"/.git &&
1126                        ! test -f "$sm_path"/.git
1127                }
1128                then
1129                        say "-$sha1 $displaypath"
1130                        continue;
1131                fi
1132                if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1133                then
1134                        set_name_rev "$sm_path" "$sha1"
1135                        say " $sha1 $displaypath$revname"
1136                else
1137                        if test -z "$cached"
1138                        then
1139                                sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
1140                        fi
1141                        set_name_rev "$sm_path" "$sha1"
1142                        say "+$sha1 $displaypath$revname"
1143                fi
1144
1145                if test -n "$recursive"
1146                then
1147                        (
1148                                prefix="$displaypath/"
1149                                sanitize_submodule_env
1150                                cd "$sm_path" &&
1151                                eval cmd_status
1152                        ) ||
1153                        die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1154                fi
1155        done
1156}
1157#
1158# Sync remote urls for submodules
1159# This makes the value for remote.$remote.url match the value
1160# specified in .gitmodules.
1161#
1162cmd_sync()
1163{
1164        while test $# -ne 0
1165        do
1166                case "$1" in
1167                -q|--quiet)
1168                        GIT_QUIET=1
1169                        shift
1170                        ;;
1171                --recursive)
1172                        recursive=1
1173                        shift
1174                        ;;
1175                --)
1176                        shift
1177                        break
1178                        ;;
1179                -*)
1180                        usage
1181                        ;;
1182                *)
1183                        break
1184                        ;;
1185                esac
1186        done
1187        cd_to_toplevel
1188        git submodule--helper list --prefix "$wt_prefix" "$@" |
1189        while read mode sha1 stage sm_path
1190        do
1191                die_if_unmatched "$mode"
1192                name=$(git submodule--helper name "$sm_path")
1193                url=$(git config -f .gitmodules --get submodule."$name".url)
1194
1195                # Possibly a url relative to parent
1196                case "$url" in
1197                ./*|../*)
1198                        # rewrite foo/bar as ../.. to find path from
1199                        # submodule work tree to superproject work tree
1200                        up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1201                        # guarantee a trailing /
1202                        up_path=${up_path%/}/ &&
1203                        # path from submodule work tree to submodule origin repo
1204                        sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1205                        # path from superproject work tree to submodule origin repo
1206                        super_config_url=$(resolve_relative_url "$url") || exit
1207                        ;;
1208                *)
1209                        sub_origin_url="$url"
1210                        super_config_url="$url"
1211                        ;;
1212                esac
1213
1214                if git config "submodule.$name.url" >/dev/null 2>/dev/null
1215                then
1216                        displaypath=$(relative_path "$prefix$sm_path")
1217                        say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1218                        git config submodule."$name".url "$super_config_url"
1219
1220                        if test -e "$sm_path"/.git
1221                        then
1222                        (
1223                                sanitize_submodule_env
1224                                cd "$sm_path"
1225                                remote=$(get_default_remote)
1226                                git config remote."$remote".url "$sub_origin_url"
1227
1228                                if test -n "$recursive"
1229                                then
1230                                        prefix="$prefix$sm_path/"
1231                                        eval cmd_sync
1232                                fi
1233                        )
1234                        fi
1235                fi
1236        done
1237}
1238
1239# This loop parses the command line arguments to find the
1240# subcommand name to dispatch.  Parsing of the subcommand specific
1241# options are primarily done by the subcommand implementations.
1242# Subcommand specific options such as --branch and --cached are
1243# parsed here as well, for backward compatibility.
1244
1245while test $# != 0 && test -z "$command"
1246do
1247        case "$1" in
1248        add | foreach | init | deinit | update | status | summary | sync)
1249                command=$1
1250                ;;
1251        -q|--quiet)
1252                GIT_QUIET=1
1253                ;;
1254        -b|--branch)
1255                case "$2" in
1256                '')
1257                        usage
1258                        ;;
1259                esac
1260                branch="$2"; shift
1261                ;;
1262        --cached)
1263                cached="$1"
1264                ;;
1265        --)
1266                break
1267                ;;
1268        -*)
1269                usage
1270                ;;
1271        *)
1272                break
1273                ;;
1274        esac
1275        shift
1276done
1277
1278# No command word defaults to "status"
1279if test -z "$command"
1280then
1281    if test $# = 0
1282    then
1283        command=status
1284    else
1285        usage
1286    fi
1287fi
1288
1289# "-b branch" is accepted only by "add"
1290if test -n "$branch" && test "$command" != add
1291then
1292        usage
1293fi
1294
1295# "--cached" is accepted only by "status" and "summary"
1296if test -n "$cached" && test "$command" != status && test "$command" != summary
1297then
1298        usage
1299fi
1300
1301"cmd_$command" "$@"